'
'  This is a simple MAIN routine to demonstrate use of the QBSVGA's mouse
' routines.  (Yout still need to link with QB.LIB or run QB with the /L
' option.)
'
'  Put the contents of REGTYPE.INC here.
'
'  Don't do anything if mouse driver isn't present.  (QRYMOUSE is the only
' mouse routine (indeed, the only one of any of the QBSVGA routines) that
' you can call without first setting the video mode with BSCREEN.)
'
IF QRYMOUSE(INREGS,OUTREGS)=-1 THEN
'
'  Mouse position detector only works with graphics screens.
'
CALL BSCREEN(14!,7!,0!,0!,INREGS,OUTREGS)
'
'  For now, SETLIM will not be used to restrict mouse cursor movement past
' the default manner in which it was used in subroutine MOUSINIT (called
' by BSCREEN).  A later example will use SETLIM explicitly.  If it was
' going to be used here, the most logical place for it would be right
' here, before beginning a programming sequence using subroutine GETPOS.
'
A$="  Move mouse around and press a button.  To terminate this example,;"
B$="leave the mouse at the same position and press any combination of"
C$="buttons twice."
CALL BPRINT("EEK!  A RODENT!  HELP!",INREGS,OUTREGS)
CALL BPRINT(" ",INREGS,OUTREGS)
CALL BPRINT("(Sorry, I couldn't resist.)",INREGS,OUTREGS)
CALL BPRINT(" ",INREGS,OUTREGS)
CALL BPRINT(A$,INREGS,OUTREGS)
'
'  The following call to BPRINT is used to put a "," at the end of the
' printed string represented by A$.  (BPRINT won't allow a comma to be
' explicitly printed at the end of a line.)
'
CALL BPRINT(" ",INREGS,OUTREGS)
CALL BPRINT(B$,INREGS,OUTREGS)
CALL BPRINT(C$,INREGS,OUTREGS)
'
'  If output position from GETPOS is same as last position, terminate
' loop.
'
X=-1 : Y=-1
TOP1:
XL=X : YL=Y
CALL GETPOS(X,Y,BUTTON,INREGS,OUTREGS)
CALL BLOCATE(10!,1!,INREGS,OUTREGS)
A$="("+LTRIM$(RTRIM$(STR$(X)))+" , "+LTRIM$(RTRIM$(STR$(Y)))+")."
A$="Cursor position = "+A$+"                                "
CALL BPRINT(A$,INREGS,OUTREGS)
IF BUTTON=0 THEN BUT$="left"
IF BUTTON=1 THEN BUT$="right"
IF BUTTON=2 THEN BUT$="middle"
CALL BPRINT("You pressed the "+BUT$+" button.        ",INREGS,OUTREGS)
IF ABS(XL-X)>.001 OR ABS(YL-Y)>.001 THEN GOTO TOP1
'
'  Use new example restricting cursor motion.
'
CALL BSCREEN(15!,7!,0!,0!,INREGS,OUTREGS)
A$="Now I'm going to restrict the motion of the cursor in a higher video mode."
CALL BPRINT(A$,INREGS,OUTREGS)
CALL BPRINT(" ",INREGS,OUTREGS)
A$="  Move mouse around and press a button.  To terminate example, leave"
B$="the mouse at the same position and press any combination of buttons"
C$="twice."
CALL BPRINT(A$,INREGS,OUTREGS)
CALL BPRINT(B$,INREGS,OUTREGS)
CALL BPRINT(C$,INREGS,OUTREGS)
CALL SETLIM(100!,100!,HMAX-100,VMAX-100,INREGS,OUTREGS)
'
'  Draw box to show where mouse limits are.
'
CALL BLINE(100!,100!,HMAX-100,VMAX-100,7!,"B",INREGS,OUTREGS)
X=-1 : Y=-1
TOP2:
XL=X : YL=Y
CALL GETPOS(X,Y,BUTTON,INREGS,OUTREGS)
CALL BLOCATE(34!,1!,INREGS,OUTREGS)
A$="("+LTRIM$(RTRIM$(STR$(X)))+" , "+LTRIM$(RTRIM$(STR$(Y)))+")"
A$="Position = "+A$+"         "
IF BUTTON=0 THEN BUT$="left"
IF BUTTON=1 THEN BUT$="right"
IF BUTTON=2 THEN BUT$="middle"
CALL BPRINT(A$,INREGS,OUTREGS)
CALL BPRINT("Button = "+BUT$+"          ",INREGS,OUTREGS)
IF ABS(XL-X)>.001 OR ABS(YL-Y)>.001 THEN GOTO TOP2
'
'  Do example involving dragging box routine.
'
CALL BCLS(0!,INREGS,OUTREGS)
CALL SETLIM(0!,0!,HMAX,VMAX,INREGS,OUTREGS)
'
'  Change colors.
'
MCOLOR=13
A$="  Press and hold a button and move mouse around.  Release button when recta"
A$=A$+"ngle"
B$="is drawn however you want."
CALL BPRINT(A$,INREGS,OUTREGS)
CALL BPRINT(B$,INREGS,OUTREGS)
CALL BOXDRAG(XP,YP,XR,YR,BUTTON,INREGS,OUTREGS)
CALL BCLS(0!,INREGS,OUTREGS)
A$="  Press a key and I will use the outputs of the BOXDRAG mouse routine to"
B$="redraw your box."
CALL BPRINT(A$,INREGS,OUTREGS)
CALL BPRINT(B$,INREGS,OUTREGS)
10 IF INKEY$="" THEN GOTO 10
XLEFT=XP : XRIGHT=XR : IF XR<XP THEN XLEFT=XR : XRIGHT=XP
YLEFT=YP : YRIGHT=YR : IF YR<YP THEN YLEFT=YR : YRIGHT=YP
CALL BCLS(0!,INREGS,OUTREGS)
CALL BLINE(XLEFT,YLEFT,XRIGHT,YRIGHT,7!,"B",INREGS,OUTREGS)
COLUMN=INT(XLEFT/8+.001)+2 : ROW=INT(YLEFT/16+.001)+2
CALL BLOCATE(ROW,COLUMN,INREGS,OUTREGS)
CALL BPRINT("This should be your box; press a key to quit.",INREGS,OUTREGS)
CALL BLOCATE(ROW+1,COLUMN,INREGS,OUTREGS)
CALL BPRINT("(Notice how I changed colors just to show that",INREGS,OUTREGS)
CALL BLOCATE(ROW+2,COLUMN,INREGS,OUTREGS)
CALL BPRINT("I was actually recreating your box?)",INREGS,OUTREGS)
20 IF INKEY$="" THEN GOTO 20
CALL BSCREEN(0!,7!,0!,0!,INREGS,OUTREGS)
ELSE
PRINT
PRINT "Install mouse driver!"
END IF
END
'
'  Put the contents of QBSVGA.BAS here.
