'
'  This is a simple routine that may aid in seeing how to use the QBSVGA
' routines and where to put REGTYPE.INC.  If you go to compile and link
' it, use QB.LIB (in addition to whatever other libraries you would
' normally use).  This applies anytime you use the QBSVGA routines.
' Similarly, if you're going to use these routines from within the QB
' IDE, run QB with the "/L" command-line option.
'
'  Put the contents of REGTYPE.INC here.
'
    DIM CLA AS LONG,Q AS LONG
    CALL BSCREEN(15!,7!,0!,0!,INREGS,OUTREGS)
    CALL BLINE(10!,10!,790!,590!,14!,"BF",INREGS,OUTREGS)
    CALL BCIRCLE(400!,300!,290!,13!,0!,0!,1!,INREGS,OUTREGS)
    CALL BCIRCLE(400!,300!,150!,12!,0!,1.57!,1!,INREGS,OUTREGS)
    S=3.141593
    E=3*3.141593/2
    CALL BCIRCLE(400!,300!,150!,11!,S,E,1!,INREGS,OUTREGS)
    CALL BLINE(30!,30!,30!,350!,15!,"L",INREGS,OUTREGS)
    CALL BCOLOR(12!)
'
'  A negative number input to any of the QBSVGA routines for the color
' will be reset to the default color defined in the call to BSCREEN
' (or COLOR).  (An exception to this is BVIEW; it uses color 0 in this
' situation.)
'
    CALL BLINE(0!,0!,799!,599!,-1!,"L",INREGS,OUTREGS)
    CALL BCOLOR(9!)
    CALL BLOCATE(30!,10!,INREGS,OUTREGS)
    CALL BPRINT("This is an example.",INREGS,OUTREGS)
    PCOLOR=BPOINT(799!,599!,INREGS,OUTREGS)
    CALL BLOCATE(3!,3!,INREGS,OUTREGS)
    A$="Color of pixel at (800,600) is "+LTRIM$(RTRIM$(STR$(PCOLOR)))+".;"
    CALL BPRINT(A$,INREGS,OUTREGS)
    CALL BPRINT("    (Wait...)",INREGS,OUTREGS)
    RX=799
    RY=599
    CALL BLINE(0!,0!,RX,RY,10!,"B",INREGS,OUTREGS)
    SLEEP 5
'
'  Before putting video mode in 640 x 480 x 256 state, make QB *think*
' that screen is in mode 13 so later use of palette command works.
'
    SCREEN 13
    CALL BSCREEN(14!,6!,0!,0!,INREGS,OUTREGS)
    CALL BLOCATE(1!,3!,INREGS,OUTREGS)
    CALL BPRINT("Now I am going to use a graphics viewport;",INREGS,OUTREGS)
    CALL BPRINT(" in a different screen mode.",INREGS,OUTREGS)
    CALL BPRINT(" ",INREGS,OUTREGS)
    CALL BPRINT("(Wait...)",INREGS,OUTREGS)
    CALL BVIEW(40!,60!,230!,250!,0!,7!,INREGS,OUTREGS)
    CALL BCIRCLE(100!,120!,40!,7!,0!,0!,2!,INREGS,OUTREGS)
'
'  Paint inside of circle.
'
    CALL BPAINT(100!,120!,11!,-1!,INREGS,OUTREGS)
'
'  Paint top, bottom, and righthand portions of exterior of circle.
'
    CALL BPAINT(141!,120!,13!,-1!,INREGS,OUTREGS)
'
'  Paint remaining portion of circle exterior.
'
    CALL BPAINT(59!,120!,13!,-1!,INREGS,OUTREGS)
    SLEEP 5
    CALL BCLS(0!,INREGS,OUTREGS)
    CALL BLOCATE(1!,10!,INREGS,OUTREGS)
    A$="Now I'm going to try to print 256 colors in that last graphics mode."
    CALL BPRINT(A$,INREGS,OUTREGS)
    CALL BLOCATE(3!,1!,INREGS,OUTREGS)
    C=0
    FOR I=33 TO 126
    CALL BCOLOR(C)
    CALL BPRINT(CHR$(I)+";",INREGS,OUTREGS)
    C=C+1
    NEXT I
    FOR I=33 TO 126
    CALL BCOLOR(C)
    CALL BPRINT(CHR$(I)+";",INREGS,OUTREGS)
    C=C+1
    NEXT I
    FOR I=33 TO 100
    CALL BCOLOR(C)
    CALL BPRINT(CHR$(I)+";",INREGS,OUTREGS)
    C=C+1
    NEXT I
    CALL BPRINT(" ",INREGS,OUTREGS)
    CALL BCOLOR(7!)
    CALL BPRINT(" ",INREGS,OUTREGS)
    CALL BPRINT(" ",INREGS,OUTREGS)
    CALL BPRINT("Now I'm going to do the same thing ;",INREGS,OUTREGS)
    CALL BPRINT("but in a more graphical manner.",INREGS,OUTREGS)
    CALL BPRINT(" ",INREGS,OUTREGS)
    CALL BPRINT(" ",INREGS,OUTREGS)
'
'  Get current row and make at least approximate conversion to pixel
' coordinates.
'
    DUMMY=BPOS(ROW,INREGS,OUTREGS)
    ROW=ROW*16
    FOR I=0 TO 511 STEP 2
    C=INT(I/2)
    CALL BLINE(I,ROW,I+1,ROW+15,C,"BF",INREGS,OUTREGS)
    NEXT I
    CALL BLOCATE(ROW/16+4,1!,INREGS,OUTREGS)
    CALL BPRINT("Press a key to see color palette change ;",INREGS,OUTREGS)
    CALL BPRINT("(and then press a key to quit).",INREGS,OUTREGS)
260 IF INKEY$="" THEN GOTO 260
'
'  The following code demonstrates that QB's PALETTE command works with
' 256-color SVGA modes.  To make this work, QB must think it's in SCREEN
' 13.  Even though the video state was changed to an SVGA mode, above,
' after using the SCREEN 13 statement, QB still thinks it's in the normal
' VGA mode; it has no idea that it's been duped.  The question then is one
' of whether or not QB'S PALETTE statement has any affect on SVGA modes.
' The answer is yes!
'
'  First 64 colors are gray-scales.
'
    FOR I=0 TO 127 STEP 2
    Q=CLNG(I/2) : B=CSNG(Q)
    CLA=65536&*Q+256&*Q+Q
    PALETTE B,CLA
    NEXT I
'
'  Next 64 colors add red to an otherwise 0 gray-scale.
'
    FOR I=128 TO 255 STEP 2
    Q=CLNG(I/2)-64& : B=CSNG(Q)+64
    PALETTE B,Q
    NEXT I
'
'  Next 64 colors add green to a maximal intensity red attribute.
'
    FOR I=256 TO 383 STEP 2
    Q=CLNG(I/2)-128& : B=CSNG(Q)+128
    CLA=256&*Q+63&
    PALETTE B,CLA
    NEXT I
'
'  Final 64 colors add blue to a maximal intensity red/green attribute.
'
    FOR I=384 TO 511 STEP 2
    Q=CLNG(I/2)-192& : B=CSNG(Q)+192
    CLA=65536&*Q+16191&
    PALETTE B,CLA
    NEXT I
270 IF INKEY$="" THEN GOTO 270
    PALETTE
    CALL BSCREEN(0!,7!,0!,0!,INREGS,OUTREGS)
    END
'
'  Put the contents of QBSVGA.BAS here.
